<script>
import { socketStore } from '@/plugins/socket.js';
import Digit from '@/components/digit.svelte';
import { onDestroy } from 'svelte';
import { splitIntoDigits } from '@/plugins/utils';
import { topics } from '@/plugins/store.js';

let dons = 0;
let unsubscribe;
$: {
    if (!unsubscribe) {
        socketStore.update(store => {
            unsubscribe = store.subscribe(message => {
                // Do something with the message here
                try {
                    let m = JSON.parse(message)

                    if ("op" in m || m.r != "pot") {
                        return
                    }

                    dons = m.d.pot;
                    dons = (dons/100).toFixed(2).toString();

                } catch (e) {
                    console.log(e)
                }
            });
            return store;
        });
    }
}

// Add a topic to the socket
topics.sub("pot");

onDestroy(() => {
    unsubscribe();
    topics.unsub("pot");
});

// Refresh in 5 minutes
setTimeout(() => {
    location.reload();
}, 300000);
</script>


<style>
    @import url('https://fonts.cdnfonts.com/css/edo'); 
    .color {
        /* beautiful gradient with light pinkish color */ 
        background: rgb(255,156,237);
        background: linear-gradient(to bottom right, rgba(124,222,255,1) 0%, rgba(255,156,237,1) 33%, rgb(181, 255, 190) 88%, rgb(237, 240, 83) 100%); 
    } 
</style>
    
<!-- Display a counter if  -->
<div class="color flex flex-col w-screen h-screen items-center justify-center absolute top-0 -z-10">
    <div class="self-center">
        <div class="flex flex-col items-center text-7xl font-extrabold -mt-20">
            <span class="mb-10">
                Cagnotte:
            </span>
            <div class="font-extrabold" style="background-color:transparent; font-size: 10rem/* 128px */; line-height: 1;">
                <div class="grid grid-flow-col text-center auto-cols-max" style="font-family: 'Edo', sans-serif; background-color:transparent">
                    {#each splitIntoDigits(dons, 2) as count}
                        <div class="flex flex-col justify-center" style="background-color:transparent">
                            <Digit digit={count}  style="background-color:transparent"/>
                        </div> 
                    {/each}
                    <span>€</span>
                </div>
            </div>
        </div>      
    </div>
</div>